﻿' Note: Set the Canvas's Background property to Brushes.White at design time.
Class Window1
    Private start_point As Point
    Private new_ellipse As Ellipse = Nothing

    ' Start the new ellipse.
    Private Sub canEllipse_MouseLeftButtonDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles canEllipse.MouseLeftButtonDown
        new_ellipse = New Ellipse()
        new_ellipse.Stroke = Brushes.Purple
        new_ellipse.Width = 0
        new_ellipse.Height = 0

        start_point = e.GetPosition(canEllipse)
        Canvas.SetTop(new_ellipse, start_point.Y)
        Canvas.SetLeft(new_ellipse, start_point.X)

        canEllipse.Children.Add(new_ellipse)
    End Sub

    ' Change the ellipse's size.
    Private Sub canEllipse_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles canEllipse.MouseMove
        If new_ellipse IsNot Nothing Then
            Dim pt As Point = e.GetPosition(canEllipse)

            Canvas.SetTop(new_ellipse, Math.Min(pt.Y, start_point.Y))
            Canvas.SetLeft(new_ellipse, Math.Min(pt.X, start_point.X))
            new_ellipse.Width = Math.Abs(pt.X - start_point.X)
            new_ellipse.Height = Math.Abs(pt.Y - start_point.Y)
        End If
    End Sub

    ' Finish the ellipse.
    Private Sub canEllipse_MouseLeftButtonUp(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles canEllipse.MouseLeftButtonUp
        new_ellipse = Nothing
    End Sub
End Class
